"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
class LatestAsync {
    constructor() {
        this.currentInvokeId = 0;
        this.onlyLatest = (promise) => new Promise((resolve, reject) => {
            const invokeId = ++this.currentInvokeId;
            let error, result;
            promise
                .then((r) => (result = r), (e) => (error = e))
                .then(() => {
                if (invokeId === this.currentInvokeId) {
                    if (error !== undefined) {
                        reject(error);
                    }
                    else {
                        resolve(result);
                    }
                }
            });
        });
        this.cancelAll = () => {
            this.currentInvokeId++;
        };
    }
}
exports.default = LatestAsync;
