"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.default = (fn, delayMs, maxDelayMs = Infinity) => {
    let lastId = undefined;
    let sequenceStarted = undefined;
    return function () {
        const now = Date.now();
        const cb = () => {
            fn.apply(this, arguments);
            sequenceStarted = undefined;
        };
        clearTimeout(lastId);
        if (sequenceStarted == undefined) {
            sequenceStarted = now;
            lastId = setTimeout(cb, delayMs);
        }
        else if (now - sequenceStarted <= maxDelayMs) {
            lastId = setTimeout(cb, delayMs);
        }
        else {
            cb();
        }
    };
};
