"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
class Mutex {
    constructor() {
        this.waiting = [];
        this.locked = false;
        this.tryProgress = () => {
            if (this.locked) {
                return;
            }
            const next = this.waiting.shift();
            if (!next) {
                return;
            }
            this.locked = true;
            next({
                unlock: () => {
                    this.locked = false;
                    this.tryProgress();
                },
            });
        };
        this.isLocked = () => this.locked;
        this.lock = () => new Promise((resolve) => {
            this.waiting.push(resolve);
            this.tryProgress();
        });
    }
}
exports.default = Mutex;
